﻿@model SecondMVCAppMy.Models.PostInTopics.PostInTopicSortAndPageModel

@{
    ViewData["Title"] = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}

<h1>Index</h1>

<div>
    <h4>ТЕМА</h4>
    <hr />
    <dl class="row">
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.TopicModel.DateOfCreation)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.TopicModel.DateOfCreation)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.TopicModel.Author)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.TopicModel.Author)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.TopicModel.TopicTitle)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.TopicModel.TopicTitle)
        </dd>
        <dt class="col-sm-2">
            @Html.DisplayNameFor(model => model.TopicModel.TopicContent)
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.TopicModel.TopicContent)
        </dd>
    </dl>
</div>


<table id="postTable" class="table">
    <thead>
        <tr>
            <th>
                <a asp-controller="PostInTopic" asp-action="Index" asp-route-sortState=@Model.DateOfPublicationSort
                   asp-route-сurrentPage=@Model.PostInTopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-topicId=@Model.TopicModel.Id>
                    @Html.DisplayNameFor(model => model.PostInTopics[0].DateOfPublication)
                </a>
            </th>
            <th>
                <a asp-controller="PostInTopic" asp-action="Index" asp-route-sortState=@Model.PostInTopicContentSort
                   asp-route-сurrentPage=@Model.PostInTopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-topicId=@Model.TopicModel.Id>
                    @Html.DisplayNameFor(model => model.PostInTopics[0].PostInTopicContent)
                </a>
            </th>
            <th>
                <a asp-controller="PostInTopic" asp-action="Index" asp-route-sortState=@Model.AuthorSort
                   asp-route-сurrentPage=@Model.PostInTopicPageModel.PageNumber
                   asp-route-page=@Model.Page
                   asp-route-topicId=@Model.TopicModel.Id>
                    @Html.DisplayNameFor(model => model.PostInTopics[0].Author)
                </a>
            </th>
            <th>
                Лайки
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model.PostInTopics)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.DateOfPublication)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.PostInTopicContent)
                </td>
                <td>
                    @Html.DisplayFor(modelItem => item.Author)
                </td>
                <td id="postInTopicCount-@item.Id">
                    @Html.DisplayFor(modelItem => item.Like)
                </td>
                <td>
                    <input type="button" value="Лайк" onclick="likePostInTopic('@item.Id')" />
                </td>
                <td>
                    <input type="button" value="Дизлайк" onclick="disLikePostInTopic('@item.Id')" />
                </td>
            </tr>
        }
    </tbody>
</table>


@if (Model.PostInTopicPageModel.HasPreviousPage)
{
    <a asp-action="Index"
       asp-route-topicId=@Model.TopicModel.Id
       asp-route-sortState="@Model.PostInTopicSortState"
       asp-route-page="@(Model.PostInTopicPageModel.PageNumber - 1)"
       class="btn btn-outline-dark btn">
        <i class="glyphicon glyphicon-chevron-left"></i>
        Prev
    </a>
}

<span style="margin: 20px">@Model.PostInTopicPageModel.PageNumber</span>

@if (Model.PostInTopicPageModel.HasNextPage)
{
    <a asp-action="Index"
       asp-route-topicId=@Model.TopicModel.Id
       asp-route-sortState="@Model.PostInTopicSortState"
       asp-route-page="@(Model.PostInTopicPageModel.PageNumber + 1)"
       class="btn btn-outline-dark btn">
        <i class="glyphicon glyphicon-chevron-right"></i>
        Next
    </a>
}

<p>

</p>

<div>
    <div><input type="button" id="addPostInTopic" class="btn-primary" value="Написать в тему" /></div>
    <div id="postinTopicForm" style="display: none">
        <div><textarea id="postInTopicText" class="form-control"></textarea></div>
        <div><input type="button" id="sendPostInTopic" class="btn-primary" value="Send" /></div>
    </div>
    <br />
    <a asp-action="Index" asp-controller="Topic">Back to List</a>
</div>

<script>
    function likePostInTopic(postInTopicId) {
        $.ajax({
            url: '@Url.Action("LikeForPostInTopic", "PostInTopic")',
            method: 'POST',
            data: { 'postInTopicId': postInTopicId },
            error: function(data) {
                console.log(data);
                alert('Error' + data.status + "\n" + data.responseText);
            },
            success: function(data) {
                $('#postInTopicCount-' + postInTopicId).html(data);
            }
        });
    }
    function disLikePostInTopic(postInTopicId) {
        $.ajax({
            url: '@Url.Action("DisLikeForPostInTopic", "PostInTopic")',
            method: 'POST',
            data: { 'postInTopicId': postInTopicId },
            error: function(data) {
                console.log(data);
                alert('Error' + data.status + "\n" + data.responseText);
            },
            success: function(data) {
                $('#postInTopicCount-' + postInTopicId).html(data);
            }
        });
    }
</script>

@section Scripts
{
    <script>

        $('#addPostInTopic').click(function () {
            //$('#postinTopicForm').val('');
            $('#postinTopicForm').show();
            $('#addPostInTopic').hide();
        });

        $('#sendPostInTopic').click(function () {

            var comment = $('#postInTopicText').val();
            var topicId = '@Model.TopicModel.Id';
            $.ajax({
                url: '@Url.Action("CreatePostInTopicAjax", "PostInTopic")',
                method: 'POST',
                data: { 'comment': comment, 'topicId': topicId },
                dataType: 'JSON',
                error: function (data) {
                    console.log(data);
                    alert('Error ' + data.status + "\n" + data.responseText);
                },
                success: function (data) {
                    $('#postinTopicForm').hide();
                    $('#addPostInTopic').show();
                    var dateOfPublicationCell = "<td>" + data.dateOfPublication + "</td>";
                    var postInTopicContentCell = "<td>" + data.postInTopicContent + "</td>";
                    var authorCell = "<td>" + data.author + "</td>";
                    var likeCell = "<td>" + data.like + "</td>";
                    var likePostInTopicCell = "<td>" + data.likePostInTopic + "</td>";
                    var disLikePostInTopicCell = "<td>" + data.disLikePostInTopic + "</td>";
                    var newRow = "<tr>" + dateOfPublicationCell + postInTopicContentCell + authorCell +
                        likeCell + likePostInTopicCell + disLikePostInTopicCell + "</tr>";
                    $('#postTable tbody').append(newRow);
                }
            });
        });

    </script>
}

